# mulesoft Mule Gateway - Full Documentation --- product: Mule Gateway --- # Anypoint Mule Gateway > For the full documentation index, see: https://docs.mulesoft.com/llms.txt Mule runtime engine includes an embedded Mule Gateway. Mule Gateway enables you to add a dedicated orchestration layer on top of your backend APIs and services to help you separate orchestration from implementation. You can leverage the governance capabilities of API Manager to apply, among other capabilities, throttling, security, caching, and logging to your APIs. For example, using Mule Gateway you can: - Apply a basic authentication policy on top of a Mule application. - Enrich an incoming or outgoing message. - Add any other complex capability to an API without having to write any code. If you want to apply policies and generate analytics info, you must use either: - An API defined in a Mule application. - A Mule application that proxies your existing backend implementation. For more information, see [Mule Gateway Overview](https://docs.mulesoft.com/mule-gateway/mule-gateway-capabilities-mule4). --- product: Mule Gateway --- # Anypoint Platform Gateways > For the full documentation index, see: https://docs.mulesoft.com/llms.txt An API gateway allows you to add a dedicated orchestration layer on top of your backend APIs and services to help you separate orchestration from implementation concerns. You can then leverage the governance capabilities of API Manager to apply, among other capabilities, throttling, security, caching, and logging to your APIs. Anypoint Platform offers three different runtime options for managing and securing your APIs. ## Omni Gateway Omni Gateway is an ultrafast API gateway designed to manage and secure APIs running anywhere. Built to seamlessly integrate with DevOps and CI/CD workflows, Omni Gateway delivers the performance required for the most demanding applications and microservices while providing enterprise security and manageability across any environment. For more information, see [Getting Started with Omni Gateway](https://docs.mulesoft.com/gateway/latest/gateway-getting-started). ## Anypoint Mule Gateway Mule runtime engine includes an embedded Mule Gateway. You can leverage the governance capabilities of API Manager to apply, among other capabilities, throttling, security, caching, and logging to your APIs. For example, using Mule Gateway you can: - Apply a basic authentication policy on top of a Mule application. - Enrich an incoming or outgoing message. - Add other complex capabilities to an API without writing code. If you want to apply policies and generate analytics info, you must use either: - An API defined in a Mule application. - A Mule application that proxies your existing backend implementation. For more information, see [Mule Gateway Overview](https://docs.mulesoft.com/mule-gateway/mule-gateway-capabilities-mule4). --- product: Mule Gateway --- # API Autodiscovery > For the full documentation index, see: https://docs.mulesoft.com/llms.txt Configuring autodiscovery allows a deployed Mule runtime engine (Mule) application to connect with API Manager to download and manage policies and to generate analytics data. Additionally, with autodiscovery, you can configure your Mule applications to act as their own API proxy. When autodiscovery is correctly configured in your Mule application, you can say that your application’s API is _tracked by_ (green dot) or _paired to_ API Manager. You can associate an API in a Mule setup with only one autodiscovery instance at a given time. > [!NOTE] The flow referenced for autodiscovery must use an > [HTTP Listener](https://docs.mulesoft.com/http-connector/1.10/http-listener-ref) component. Other connectors that use > HTTP as an underlying transport aren’t supported for policy enforcement. ## Prerequisites To [configure autodiscovery for your Mule application](https://docs.mulesoft.com/mule-gateway/mule-gateway-config-autodiscovery-mule4), ensure that: - The API exists in API Manager and is configured as either a basic endpoint, or a proxy endpoint. - The Mule application is configured to use Anypoint Platform credentials. The platform credentials give your application access to the API Configuration in API Manager. You must configure your platform credentials before starting Mule. - The autodiscovery element is configured in your Mule application. This XML element must point to the specific API in API manager which you want to pair to. ## Proxy Endpoint vs Basic Endpoint If you configured a proxy endpoint, your autogenerated proxy is already correctly configured with the autodiscovery element. Additionally, if you want to take advantage of the platform deployment capabilities, such as 1-Click deployment, the API Manager credentials are automatically set for you. ## See Also - [API Proxy](https://docs.mulesoft.com/api-manager/latest/api-proxy-landing-page) - [Configuring API Autodiscovery in a Mule 4 Application](https://docs.mulesoft.com/mule-gateway/mule-gateway-config-autodiscovery-mule4) - [Configuring Organization Credentials in Mule Runtime 4](https://docs.mulesoft.com/mule-gateway/mule-gateway-org-credentials-mule4) --- product: Mule Gateway keywords: api security, identification, correlation, api gateway, mule gateway, gateway, policy --- # API Security-Identification Header Policy > For the full documentation index, see: https://docs.mulesoft.com/llms.txt

Policy Name

API Security-Identification Header

Summary

Adds API instance identifiers as response headers for external security platform correlation

Category

Security

First Mule version available

v4.12.0

Returned Status Codes

No return codes exist for this policy.

## Summary The API Security-Identification Header policy injects organization and API instance identifiers as response headers to enable integration with external security platforms such as Akamai. The policy adds these headers in the response phase: - `x-ms-correlation-id-1`: Contains the business group ID - `x-ms-correlation-id-2`: Contains the API instance ID The policy has no configuration parameters and operates transparently without blocking traffic. If the required metadata is unavailable, the response continues without the headers and a warning is logged for each missing identifier. If the backend already returns `x-ms-correlation-id-1` or `x-ms-correlation-id-2` headers, the policy overwrites these values with the platform metadata values. ## Configuring Policy Parameters This policy has no user-configurable parameters, but the policy requires the following system properties to be configured for the Mule runtime: - `anypoint.platform.client_id`: The client ID for authenticating with Anypoint Platform - `anypoint.platform.client_secret`: The client secret for authenticating with Anypoint Platform - `anypoint.platform.base_uri`: The base URI for the Anypoint Platform API (for example, `[https://anypoint.mulesoft.com](https://anypoint.mulesoft.com)`) > [!NOTE] These properties are typically configured automatically when running Mule runtime with > Anypoint Platform. ## Logging The policy logs the following information: - **INFO level**: Organization ID retrieval status during policy initialization (for example: `OrgIdRetriever.initialise() complete — organizationId=`) - **WARN level**: When system properties are not configured or when organization ID retrieval fails during initialization ## Example Response Given the following metadata: - Organization ID: `a1b2c3d4-e5f6-7890-abcd-ef1234567890` - API instance ID: `19203842` The policy adds the following response headers: x-ms-correlation-id-1: a1b2c3d4-e5f6-7890-abcd-ef1234567890 x-ms-correlation-id-2: 19203842 --- product: Mule Gateway keywords: policy, endpoint --- # Apply a Policy > For the full documentation index, see: https://docs.mulesoft.com/llms.txt For Mule Gateway, you apply included policies via **API Manager**. The following steps demonstrate this. You can apply a policy either to the entire API (default) or to specific methods and resources of an API. > [!NOTE] To apply a policy for Mule Gateway, a Mule application must first be deployed with a flow > that uses an [HTTP Listener](https://docs.mulesoft.com/http-connector/1.10/http-listener-ref) component and is linked to > the API through autodiscovery. The flow must use the HTTP Listener component specifically, not > other connectors that use HTTP as an underlying transport. To apply a policy: 1. Go to **Anypoint Platform > API Manager**. 2. In **API Administration** click the name of the API to which to apply a policy. 3. From the left navigation menu, click **Policies**. 4. Click **\+ Add policy**. 5. Select the policy to apply. 6. Configure the required configuration parameters. For policy configuration parameters, see [Included Policies Directory](https://docs.mulesoft.com/mule-gateway/policies-included-directory). 7. Click **Apply** ## Upgrade a Policy Definition To upgrade a policy in API Manager: 1. Go to **Anypoint Platform > API Manager**. 2. In **API Administration** click the name of the API with the policy to upgrade. 3. From the left navigation menu, click **Policies**. 4. Click the more options menu (![1%](/mulesoft/current/en-us/mule-gateway/_images/more-options-menu.png)) of the policy to upgrade, and then click **Edit configuration**. 5. Select the **latest** version for **Policy version**. 6. Click **Save**. > [!NOTE] You must manually check for implementation version updates only when upgrading the > **patch** version of a definition (for example, 1.0.0 to 1.0.1). For **minor** and **major** > version upgrades (for example, 1.0.0 to 1.1.0 or 1.0.0 t0 2.0.0), the implementation updates > automatically. To upgrade a policy implementation, see > [Upgrade a Policy Implementation](#upgrade-policy-implementation). ## Upgrade a Policy Implementation To upgrade a policy implementation in API Manager: 1. Go to **Anypoint Platform > API Manager**. 2. In **API Administration** click the name of the API with the policy to upgrade. 3. From the left navigation menu, click **Policies**. 4. Click the more options menu (![1%](/mulesoft/current/en-us/mule-gateway/_images/more-options-menu.png)) of the policy to upgrade, and then click **Check for implementation updates**. 5. If implementation updates are available, click **Update all**. 6. Click **Ok**. --- product: Mule Gateway --- # Applying Automated Policies > For the full documentation index, see: https://docs.mulesoft.com/llms.txt Users with **Organization Admin**, **Environment Admin**, or with a role to **Manage Policies** in the environment can create, edit and delete Automated Policies. ## Task Prerequisites Before you apply an automated policy, ensure that: - Mule runtime engine (Mule) is installed with [Mule Gateway capabilities](https://docs.mulesoft.com/mule-gateway/mule-gateway-capabilities-mule4) enabled. - An [API](https://docs.mulesoft.com/api-manager/latest/api-instance-landing-page) configured with a basic endpoint or a proxy endpoint exists in API Manager. - A Mule application is deployed with a [HTTP(s) based flow](https://docs.mulesoft.com/http-connector/1.10/http-listener-ref), which is linked to the API through Autodiscovery. When Autodiscovery is correctly configured in your Mule application, your application’s API is said to be tracked by or paired to API Manager. Autogenerated proxies handle these prerequisites in most cases. Mule Gateway reconciles the automated policies applied to an API in API Manager during runtime. ## Apply Automated Policy To apply an automated policy: 1. In **API Manager**, select **Automated Policies** from the left navigation menu. 2. Click **Apply new automated policy**. 3. Select the provided policy that you want to configure as a provided policy. You can configure any provided policies for Mule 4 as an automated policy. See the [list of available Provided Policies](https://docs.mulesoft.com/gateway-home/) to learn how to configure each one of them. When configuring an automated policy, at the end of the policy configuration page, there is a **Rule of Applications** sub-section. This section dictates the set of runtimes that the policy affects. Configure the following parameters: - **Version Range** You can configure a range of Mule runtime versions to inherit the automated policy. For example, if the input **From Version** is 4.1.2 and the **To** is 4.1.4, the automated policy is applied to all deployed APIs inside this range. An API deployed on 4.1.5 is not be affected by the policy. You can include values such as `4.1.x`. For example, adding a range from 4.1.1 to 4.1.x covers all runtime patch releases. An API Proxy based on 4.1.0 is not included in this range, because it’s lower than the 4.1.1. If you are configuring a type of policy that also exists as a provided policy in an API proxy affected by your rule of application, you must solve the conflict before continuing. Refer to the [Conflict Management](#conflict-management) section below for more information on how to solve them. - **Java versions** Select to apply the policy to **All Java versions** or **Choose specific Java versions**. If you choose to apply the policies to specific Java versions, chose either **Java 8**, **Java 17**, or both. 4. Click **Apply**. > [!TIP] It’s recommended to apply an automated policy in a lower environment before applying in a > production environment and ensure to review that an automated policy doesn’t affect the existing > API contracts. ## Conflict Management Since automated policies have priority over API level policies, when adding an automated policy that it is already applied as an API Level policies, on API deployed using the selected runtime range, a conflict will be detected that needs to be solved before proceeding. When a conflict is detected, a popup with the list of conflicting APIs will be displayed. A message will be shown with the first 10 APIs with conflicts and the total amount. You can use this endpoint to access the list of all APIs: ```CURL curl -X GET \ https://anypoint.mulesoft.com/xapi/v1/automated-policies/{groupId}/{assetId}/conflicting-apis \ -H 'Authorization: Bearer {token}' ``` To solve conflicts, you can either select the APIs from the list of already configured APIs and manually disable or remove the conflicting policy or choose to override all conflicting policies for the already configured APIs. If this last option is chosen the conflicting policies in the APIs will be disabled. If Automated Policy is removed, the API policy will be re-enabled automatically. ## Deploying New APIs When managing new APIs, you can see information regarding the status of the automated policies applied to your environment in the **Policies** tab. No automated policies are shown until the application is in Active status. After the application is deployed, a list of applied automated policies will be listed in the **Policies** tab of the API. Users with **View Policies** role for the environment will able to see the list of automated policies applied. If an application is deployed to an environment which has an automated policy that doesn’t cover the deployed runtime, for example with an automated policy affecting a runtime range from 4.1.2 to 4.1.4, and a user deploys to a 4.1.5 runtime, a notification will be sent to the organization, and environment administrators, to let them know of this activity. ### Viewing Coverage Status View the **Coverage status** of an API instance to see if an automated policy covers your API instance or why it doesn’t. Typically, instances are not covered due to their runtime type or runtime version. To view what API instances are covered by an automated policy: 1. Navigate to **Anypoint Platform** > **API Manager**. 2. In API Administration, click **Automated Policies**. 3. Click the more options button (![Three circles displayed horizontally, representing the More Options menu](/mulesoft/current/en-us/mule-gateway/_images/more-options-menu.png)) of the policy whose coverage you want to view, and then click **See covered APIs**. 4. View the API instance’s coverage status in the **Coverage status** column. > [!NOTE] To filter by coverage status, click the coverage status dropdown and select a coverage > status option. ## Auditing Applied Policies It is possible to audit and get a list of all affected APIs by an automated policy. Reports can be filtered by runtime version, and by an operation. To get the list of all automated policies in an environment ```curl curl -X GET \ https://anypoint.mulesoft.com/apimanager/api/v1/organizations/{organizationId}/automated-policies?environmentId={envId} \ -H 'Authorization: Bearer {token}' ``` To get the list of APIs included in the range of automated policy or APIs where the automated policy is not applied. ```curl curl -X GET \ https://anypoint.mulesoft.com/apimanager/api/v1/organizations/{organizationId}/automated-policies/{automatedPolicyId}/apis \ -H 'Authorization: Bearer {token}' ``` ## See Also - [Included Policies](https://docs.mulesoft.com/mule-gateway/policies-included-directory) --- product: Mule Gateway --- # Applying Offline Custom Policies > For the full documentation index, see: https://docs.mulesoft.com/llms.txt An offline policy is applied directly to the runtime and not through API Manager. When you create a file in the offline-policies directory, Mule runtime engine (Mule) detects the presence of the file and starts applying the policy. Mule then generates the JSON and XML policy files in a new directory in `%MULE_HOME%/policies`. ## Task Prerequisites Before you apply an offline custom policy, ensure that: - Mule runtime engine (Mule) is installed with [Mule Gateway capabilities](https://docs.mulesoft.com/mule-gateway/mule-gateway-capabilities-mule4) enabled. - An [API](https://docs.mulesoft.com/api-manager/latest/api-instance-landing-page) configured with a basic endpoint or a proxy endpoint exists in API Manager. - A Mule application is deployed with a [HTTP(s) based flow](https://docs.mulesoft.com/http-connector/1.10/http-listener-ref), which is linked to the API through Autodiscovery. When Autodiscovery is correctly configured in your Mule application, your application’s API is said to be tracked by or paired to API Manager. ## Apply an Offline Custom Policy To apply an offline custom policy: 1. If you do not want to use the policy template from Exchange due to various reasons, place the template JAR in the following directory before you apply the offline policy to the API. `%MULE_HOME%/policies/policy-templates` 2. Create a JSON file in `%MULE_HOME%/policies/offline-policies` directory that defines the policy configuration. 3. Name the JSON file after the policy ID. 4. In the file, include the following configuration specifications: - Policy template information Specify the Exchange groupId, assetId, and version of the template used to deploy the offline policy definition. - IDs of the APIs that the policy will be applied to - A list of resources that the policy will be applied to - Order of the policy - Parameters if the defined template is using handlebars variables The following example shows a typical offline policy definition: { "template" : { "groupId" : "com.mulesoft.anypoint", "assetId" : "policyTemplate", "version" : "0.1.0" }, "api": \[ { "id": "1" }, { "id": "2" } \], "order": 1, "configuration" : { "payload" : "Payload" } } 5. After you apply a custom offline policy, you must manually deploy it to a Mule runtime engine (Mule) file system. ## See Also - [Removing Offline Custom Policies](https://docs.mulesoft.com/mule-gateway/policies-custom-offline-remove) --- product: Mule Gateway --- # Automated Policies > For the full documentation index, see: https://docs.mulesoft.com/llms.txt Use automated policies to enforce security and logging requirements by applying the same policies to all APIs running in Mule. With policy automation, you can quickly design, build, and deploy secure and consistent APIs. Automated policies enable you to deploy APIs with confidence because the target environment automatically enforces critical policies, resulting in reduced errors. An administrator no longer needs to remember to insert a policy to enforce common standards manually. You can configure all [included policies](https://docs.mulesoft.com/mule-gateway/policies-included-directory) and [custom policies](https://docs.mulesoft.com/mule-gateway/policies-custom-overview) as automated policies and apply them to the APIs running in an environment. ## Automated Policies in Mule The following rules apply to automated policies in Mule runtime engine (Mule): - Automated policies are available only for Mule 4 APIs using a MuleSoft-hosted control plane. - Automated policies support all runtime deployment targets (CloudHub, Runtime Fabric, and hybrid). - Automated policies have priority over the same types of policies already applied to a specific API proxy. For example, if an API proxy running Mule 4.1.2 has an IP Allowlist policy to allow only the IP range 192.168.100.0/22 (from 192.168.100.0 to 192.168.103.255), and a new IP Allowlist automated policy is created to only allow the IP range 192.168.100.14/24 (from 192.168.100.0 to 192.168.100.255) and is applied to all supported Mule versions (4.1.1 and above), then this latter automated policy prevails. Note that in the above example, the IP range changed when the automated policy was applied. Additionally, if there is an automated policy already applied, you cannot apply that specific type of policy as a provided policy in a specific API proxy. - As an administrator, you can apply policies specific to external identity providers (IdPs, such as OpenID) if the environment to which you want to apply policies includes them. The policy is then enforced only on those APIs that have the same IdPs configured. For example, if you apply the PingFederate Access Token Enforcement policy, the policy is enforced on only those APIs that are configured to use PingFederate as the IdP. > [!NOTE] [Alerts](https://docs.mulesoft.com/api-manager/latest/using-api-alerts) cannot be added to API instances > protected by automated policies. ## See Also - [Applying Automated Policies](https://docs.mulesoft.com/mule-gateway/policies-automated-applying) --- product: Mule Gateway keywords: basic authentication, ldap, api gateway, mule gateway, gateway, policy --- # Basic Authentication: LDAP Policy > For the full documentation index, see: https://docs.mulesoft.com/llms.txt

Policy Name

Basic Authentication: LDAP

Summary

Allows access based on the basic authorization mechanism, with user-password defined on LDAP

Category

Security

First Mule version available

v4.0.0

Returned Status Codes

401 - Unauthorized or invalid client application credentials

## Summary The Lightweight Directory Access Protocol (LDAP) authentication policy specifies how to restrict access to an API using LDAP authentication mechanism. This policy is available in Omni and Mule 4 or later. When an error is encountered, the Basic Authentication - LDAP policy returns an "WWW-Authenticate" HTTP header field using the format:\`WWW-Authenticate: Basic realm="mule-realm"\`. LDAP is an inverted tree, and each leaf has a username-password pair and associated metadata. Each level is like a tree branch. For more information about LDAP, see [About LDAP](https://en.wikipedia.org/wiki/Lightweight_Directory_Access_Protocol). ## Configuring Policy Parameters ### Mule Gateway When you apply the Basic Authentication - LDAP policy to your API from the UI, you can configure the following parameters to connect to your LDAP or Active Directory:
ParameterDescription

LDAP Server URL

The URL of your LDAP OR LDAPS server, including the port number.

LDAP User DN

The name of the user or user group with access to traverse and list users of LDAP.

LDAP User Password

The password for the user or user group. The password must be a secure value that, once specified, is not visible or retrievable.

LDAP Search Base

The starting point for the search in the directory tree.

LDAP Search Filter

The criteria for the filter for the Active Directory or the OpenLDAP model, as shown in the examples.

Note that all parameters are required to successfully configure LDAP or Active Directory. ## Example Configuration for an Active Directory You can configure Active Directory for your LDAP authentication by providing the following values:
FieldExample Literal String ValueExample Secure Property Placeholder

LDAP Server URL

ldap://174.19.33.17:389/

${ldap.server.url}

LDAP Secure Server URL (SSL)

ldaps://my-company-ldap.cloudhub.io:1010/

${ldap.server.url}

LDAP Server User DN

CN=Administrator,CN=Users,DC=my-company,DC=com

${ldap.user.dn}

LDAP User Password

somePassword

${ldap.password}

LDAP Search Base

CN=Users,DC=my-company,DC=com

${ldap.search.base}

LDAP Search Filter

(sAMAccountName={0})

${ldap.search.filter}

The search filter string in the example is specific to Active Directory applications. ## Example Configuration for OpenLDAP You can configure OpenLDAP for your LDAP authentication by providing the following values:
FieldExample Literal String ValueExample Secure Property Placeholder

LDAP Server URL

ldap://174.19.33.17:389/

${ldap.server.url}

LDAP Secure Server URL (SSL)

ldaps://my-company-ldap.cloudhub.io:1010/

${ldap.server.url}

LDAP Server User DN

cn=Manager,dc=my-company,dc=com

${ldap.user.dn}

LDAP User Password

somePassword

${ldap.password}

LDAP Search Base

ou=people,dc=my-company,dc=com

${ldap.search.base}

LDAP Search Filter

(uid={0})

${ldap.search.filter}

The search filter string in the example is specific to OpenLDAP applications. ## How This Policy Works The Basic Authentication - LDAP policy intercepts the request to the protected resource and looks for the `Authorization` HTTP header. The policy then extracts the username and password encoded in Base64 and then requests the configured LDAP instance to determine if the user credentials are correct in the provided LDAP context. You can configure the Basic Authentication: LDAP policy to credentials using the following methods: - Search for the valid username and password pair in the level specified. - Search for the valid username and password pair in the level specified, including lower levels. This search option is comprehensive, however, can result in slow performance. ### Search Scope Your search scope options differ depending on your policy version. The search scope options are one level for LDAP 1.0.0 and two levels (subtree) for LDAP 1.1.0. You can choose between `one level` and `subtree` search scopes by using the `LDAP Search in subtree` option. The `LDAP search base` is the starting point for the search in the directory. ### One-Level Search Scope With this option, the filter affects only the objects immediately subordinate to the `LDAP search base`, and not the `LDAP search base` itself. In the following example, the first level has four entries: two users and two groups. These are the only entries that are a part of any search: ![A hierarchical chart displays organizational structure and user IDs](/mulesoft/current/en-us/mule-gateway/_images/search-scope.png) If you set the search filter to `(uid={0})`, only `Jane` and `Paul` are found. The group entries are not considered. #### Subtree Search Scope With this option, the Basic Authentication - LDAP policy examines the subtree below the `LDAP search base` and also includes the `LDAP search base` level. Notice that performance is affected by this behavior. In the previous example, the analyzed area covers the entire organization. The group and user entries are considered at any level of the organization: ![A hierarchical chart displays a company’s organizational structure](/mulesoft/current/en-us/mule-gateway/_images/search-scope2.png) ## Creating Requests for APIs with Basic Authentication Policies Applied After applying the Basic Authentication - LDAP policy to the API, a request to that API must contain the following header: Authorization: Basic The `username:password` value must be a Base64-encoded string. For example on a Mac OS X or Linux system, the username and password requirement is implemented as: `echo -n ':' | base64` Mule runtime engine (Mule) separates the credentials of the header and sends the request to the LDAP server with the search filter. From the `username` and search filter, LDAP finds the registered user and then verifies credentials. The valid result is returned to Mule: ![A sequence diagram that illustrates the message flow for client authentication through an LDAP Server](/mulesoft/current/en-us/mule-gateway/_images/ldap-verification.png) The following diagram illustrates an invalid request: ![A sequence diagram that illustrates the message flow for authorization](/mulesoft/current/en-us/mule-gateway/_images/ldap-verification-invalid.png) The Basic Authentication: LDAP policy throws an HTTP 401 status code to indicate that the authorization header is malformed, not provided, or invalid. --- product: Mule Gateway keywords: basic authentication, api gateway, mule gateway, gateway, policy --- # Basic Authentication: Simple Policy > For the full documentation index, see: https://docs.mulesoft.com/llms.txt

Policy Name

Basic Authentication: Simple

Summary

Allows access based on the basic authorization mechanism, with a single user-password

Category

Security

First Mule version available

v4.0.0

Returned Status Codes

400 - Unauthorized or invalid client application credentials in WSDL API using SOAP 1.2

401 - Unauthorized or invalid client application credentials in HTTP or RAML APIs

500 - Unauthorized or invalid client application credentials in WSDL API using SOAP 1.1

## Summary The Basic Authentication: Simple policy protects an API by forcing applications to provide a username and password when making requests. The policy follows [basic HTTP authentication standards](https://datatracker.ietf.org/doc/html/rfc7617). When an error is encountered, the policy returns an "WWW-Authenticate" HTTP header field. ## Configuring Policy Parameters ### Mule Gateway When you apply the Basic Authentication: Simple policy to an API, a request to that API must contain the following header: Authorization: Basic The `username:password` value must be a base64-encoded string. For example on a Mac OS X or Linux system, the username and password requirement is implemented as: `echo -n ':' | base64` --- product: Mule Gateway --- # Caching in a Custom Policy for Mule 4 > For the full documentation index, see: https://docs.mulesoft.com/llms.txt When a value needs to be retrieved from an external system, like a token, to be used in an app or a policy, the value can be stored temporarily in the [Mule 4 Object Store](https://docs.mulesoft.com/object-store-connector/latest/). Information on the [Object Store connector is available in Anypoint Exchange](https://www.anypoint.mulesoft.com/exchange/org.mule.connectors/mule-objectstore-connector/). See also the [Object Store backend documentation](https://docs.mulesoft.com/object-store/). You can enable access to Object Store from Anypoint Platform > Runtime Manager. However, the Runtime Manager object store is only for [CloudHub](https://docs.mulesoft.com/cloudhub/) and hybrid applications. An application that stores the data in the object store can, or any of its workers, retrieve the data. The object store provides the cache for your custom policy, thus avoiding making external calls multiple times. In addition, the object store can be used by multiple policies applied in different APIs running in different instances in CloudHub. ## Caching with the Object Store Mule provides the Mule 4 Object Store connector that retrieves and stores values for up to 30 days. The following example retrieves data from an object store and if no data is found for a specific key, a new value is retrieved from the external system and stored in the object store. ```xml #[vars.myVar] ``` In this example, the `` statement executes the retrieve operation of the Object Store connector using the value token as the key to look for and assign the retrieved value to the `myVar` variable. If no value is associated with a key, an error is thrown by the retrieve operation. This is why the operation is enclosed in a `` block, so that should an error occur, it can be handled by retrieving a fresh value and storing it in the object store. The HTTP request is implemented inside the `` block. The value is obtained through an HTTP call and assigned to the `myVar` variable. Then that value is stored in the object store using the `store` operation of the Object Store connector. After this block executes, myVar contains a value that was retrieved from either the cache or the external system, and stored in the cache for later use. You can use that value for any purpose such as adding it as a new header to a request or response, or more. ## Defining an Object Store To use the Object Store connector operations, you need to first define the object store that those operations use. The following configuration defines the myObjectStore and stores the values for an hour. The object store in this example is set to be persistent so that if the runtime is restarted, the Object Store won’t be cleared. ```xml ``` The time to live (TTL) value is set to 1 hour. ## Caching in Runtime Manager When the policy is deployed to an API running in Runtime Manager and that instance also has the Object Store v2 (OSv2) enabled, then using the above persistent object store configuration results in the policy caching the values into the Cloud Object Store. However, there is a limitation, as the configured entry time to live is not honored when using it, as the Object Store connector is not able to create new stores, but rather it uses the default object store partition that has a 30 days TTL. ## Enabling an Object Store for Multiple APIs When using Object Store v2, you can share the cache between multiple API deployments. To achieve this, the object store configuration needs to have the same name attribute in every deployed policy and also the runtime needs to have a system property named `objectstore.enable.global.sharing` that is set with the value true. After enabling this, data persisted by a policy running in that instance is also available to policies running in other instances under the same environment. **Caution:** Enabling the global sharing OSv2 mode makes that object store used by the application or any other policy also shared across all your organization’s APIs. ## Reviewing full example of a Policy Caching with an Object Store This example shows a policy that adds a header to an incoming HTTP Request with a value retrieved from an external system and cached in the Mule Object Store. ```xml #[vars.myVar] #[{'new-custom-header': vars.myVar}] ``` The necessary dependencies for the example are: ```xml org.mule.connectors mule-http-connector 1.2.1 mule-plugin provided org.mule.connectors mule-objectstore-connector 1.1.1 mule-plugin com.mulesoft.anypoint mule-http-policy-transform-extension 1.1.0 mule-plugin ``` ## See Also - [Object Store backend documentation](https://docs.mulesoft.com/object-store/) --- product: Mule Gateway keywords: clientid enforcement, api gateway, mule gateway, gateway, policy --- # Client ID Enforcement Policy > For the full documentation index, see: https://docs.mulesoft.com/llms.txt

Policy Name

Client ID Enforcement

Summary

Allows access only to authorized client applications

Category

Compliance

First Mule version available

v3.8.0

Returned Status Codes

401 - Unauthorized or invalid client application credentials

500 - Bad response from authorization server, or WSDL SOAP Fault error

## Summary The Client ID Enforcement policy restricts access to a protected resource by allowing requests only from registered client applications. The policy ensures that the client credentials sent on each request have been approved to consume the API. When a client application is registered in Anypoint Platform, a pair of credentials consisting of a client ID and client secret is generated. When the client application requests access to an API, a contract is created between the application and that API. An API that is protected with a Client ID Enforcement policy is accessible only to applications that have an approved contract. When you apply a Client ID Enforcement policy, access to your API is tracked by reporting the client ID along with the analytics events. You can configure Mule runtime engine (Mule) to encrypt all sensitive information that pertains to policies, contracts, and initialization data. Default policies that internally enforce client application credentials include: - [Rate Limiting: SLA-Based Policy](https://docs.mulesoft.com/mule-gateway/policies-included-rate-limiting-sla) - [OAuth 2.0 Access Token Enforcement Using Mule OAuth Provider Policy](https://docs.mulesoft.com/mule-gateway/policies-included-oauth-access-token-enforcement) - [PingFederate OAuth 2.0 Token Enforcement Policy](https://docs.mulesoft.com/mule-gateway/policies-included-pingfederate-oauth-token-enforcement) - [OpenAM OAuth 2.0 Token Enforcement Policy](https://docs.mulesoft.com/mule-gateway/policies-included-openam-oauth-token-enforcement) - [JWT Validation Policy](https://docs.mulesoft.com/mule-gateway/policies-included-jwt-validation) Although token enforcement policies can optionally skip client validation, it is recommended that you enforce the validation to ensure that the token is associated to an approved contract. ## Configuring Policy Parameters ### Mule Gateway When you apply the policy to your API from the UI, a list of parameters are displayed based on whether your environment includes Mule or non-Mule applications. #### Configuring the Parameters For Mule applications, the following parameters are displayed:
ParameterDescriptionRequired

Credentials origin

Specifies from where in the request to extract the values:

  • HTTP Basic Authentication Header: Requires credentials as part of the authorization header. The application consuming the API must use the basic authentication scheme to send the credentials in the requests.

  • Custom Expression: Accepts a DataWeave 2.0 expression for each client ID and client secret, indicating where to extract the credentials from the request. Use this option to send the credentials in a custom header or any other format. You can leave the field blank to configure the client secret requirement as optional.

Must choose from one of the options.

Client ID Expression

The DataWeave 2.0 expression to use for obtaining the client ID from API requests.

Yes.

Client Secret Expression

The DataWeave 2.0 expression to use for obtaining the client secret from API requests.

No.

Method & Resource conditions: Apply configurations to all API methods & resources

Choose this option if you require the policy to be applied to all the methods and resources associated with the API.

Must choose from one of the options.

Method & Resource conditions: Apply configurations to specific methods & resources

Choose this option if you require the policy to be applied to only specific methods and resources associated with the API.

Must choose from one of the options.

## How This Policy Works Before a client application is allowed to consume an API protected by a Client ID Enforcement policy, the client application must request access to the API. After an approved contract exists between the client application and the API, every request must include the client application credentials in compliance with how the policy is configured. For example, if the policy is configured to expect a client ID and client secret as query parameters, the application must send those credentials in the request. To enforce this, add a `client-id-required` RAML trait to the API specification: traits: client-id-required: queryParameters: client\_id: type: string client\_secret: type: string Apply the trait to the resources or methods using the `is` RAML attribute: /example: get: is: \[client-id-required\] description: Example description ## Configuring How the Policy Obtains Credentials You can configure the policy to extract either both the client ID and client secret, or only the client ID from the HTTP request by using a variety of custom DataWeave 2.0 expressions. The following examples use a client ID of '1234' and a client secret of 'abcd'. ### Obtaining Credentials Using HTTP Headers Example request using curl: ```text curl "http://localhost/myResource" -H "client_id:1234" -H "client_secret:abcd" ``` Example DataWeave 2.0 expression to be used when configuring the policy: ```text #[attributes.headers['client_id']] #[attributes.headers['client_secret']] ``` In this example, the policy is configured to expect two headers: client\_id and client\_secret, with the pair of credentials. The policy is flexible to allow other types of headers also. This is the default configuration for the policy. ### Obtaining Credentials Using HTTP Query Parameters Example request using curl: ```text curl "http://localhost/myResource?client_id=1234&client_secret=abcd" ``` Example DataWeave 2.0 expression to be used when configuring the policy for Mule 4: ```text #[attributes.queryParams.'client_id'] #[attributes.queryParams.'client_secret'] ``` In this example, the requester must send the two specified query parameters with the request. Although this is a supported configuration, it poses possible security risks. The recommended method is to use headers. DataWeave 2.0 is fully supported in Mule 4 as wells as a subset in Omni. ### Obtaining Credentials Using HTTP Request Payload (Mule only) Example request using curl: ```text curl "http://localhost/myResource" -d '{"client_id":"1234", "client_secret":"abcd"}' -X POST ``` Example DataWeave 2.0 expression to be used when configuring the policy: ```text #[payload.client_id] #[payload.client_secret] ``` Although you can configure the policy to obtain the credentials from the request payload, this option is not recommended because it is harder to reflect in the API specification. ### Obtaining Credentials Using Basic Authorization header Example request using curl: ```text curl "http://localhost/myResource" -u 1234:abcd ``` ## Configuring API Specifications The Client ID Enforcement policy requires changes in your API specification to implement the credentials requirement. You can find the RAML or OAS snippet link containing the RAML or OAS code you need to add to the API specification in the corresponding policy. You can access this code from the list of applied policies in the Policies tab of your API specification in API Manager. ## Policy Output When an HTTP request is performed against a protected resource for which the Client ID Enforcement policy is applied, and the client application credentials are invalid or unauthorized, the HTTP response includes a WWW Authenticate header with the following values:

Custom mode

Header 'WWW-Authenticate'='Client-ID-Enforcement'

Basic Auth mode

Header 'WWW-Authenticate'='Basic realm="mule-realm"

For SOAP applications, the response is a SOAP error. ## See Also - [Rate Limiting: SLA-Based Policy](https://docs.mulesoft.com/mule-gateway/policies-included-rate-limiting-sla) - [OAuth 2.0 Access Token Enforcement Using Mule OAuth Provider Policy](https://docs.mulesoft.com/mule-gateway/policies-included-oauth-access-token-enforcement) - [PingFederate OAuth 2.0 Token Enforcement Policy](https://docs.mulesoft.com/mule-gateway/policies-included-pingfederate-oauth-token-enforcement) - [OpenAM OAuth 2.0 Token Enforcement Policy](https://docs.mulesoft.com/mule-gateway/policies-included-openam-oauth-token-enforcement) - [JWT Validation Policy](https://docs.mulesoft.com/mule-gateway/policies-included-jwt-validation) - [Managing API Instance Contracts on API Manager](https://docs.mulesoft.com/api-manager/latest/manage-client-apps-latest-task) - [Getting Client ID and Client Secret of a Registered Client App](https://docs.mulesoft.com/api-manager/latest/access-client-app-id-task) - [OpenID Connect OAuth 2.0 Token Enforcement Policy](https://docs.mulesoft.com/mule-gateway/policies-included-openid-token-enforcement) - [Mule Gateway Startup Encryption](https://docs.mulesoft.com/mule-gateway/mule-gateway-encryption-mule4) --- product: Mule Gateway --- # Collecting Mule Gateway Metrics > For the full documentation index, see: https://docs.mulesoft.com/llms.txt Mule Gateway is enabled, by default, to collect relevant usage data for improving user experience. MuleSoft uses this data to analyze and better understand the Mule Gateway capabilities uniformly for all customers. The metrics collected by Mule Gateway include: - Number and types of applications, APIs, and policies deployed - Mule Gateway-related configuration parameters - Statistics about the number of requests processed Note that sensitive information, such as credentials and policy configuration parameters, is not collected. This feature is included in the 3.9.5, 4.2.2, and 4.3.0 versions of Mule runtime engine. ## Disable Mule Gateway Metrics Collection Even though no sensitive information is collected using this configuration, you might still want to disable it for some reason. To disable the configuration, add the following entry in the `wrapper.conf` file: `anypoint.platform.metrics_enabled=false` ## Log Analytics Event Data Mule Gateway provides `INFO` API analytics event logging to capture data about incoming API requests. > [!NOTE] API analytics event logging is only supported in Mule runtime versions 4.4.x and 4.5.x > released after Feb 1, 2024 and Mule runtime versions 4.6.0 and later. By default, `anypoint.platform.log_analytics_events=false`. Enable event logging by adding the following entry to the `wrapper.conf` file: ```conf anypoint.platform.log_analytics_events=true ``` > [!IMPORTANT] Due to additional log generation, events logging might affect the performance of the > request processing. Logs appear in the following format: com.mulesoft.mule.runtime.gw.analytics.logger.AnalyticsHttpEventsLogger: {"api\_id":XX,"api\_version\_id":XX,"org\_id":"XXX","host\_id":"XXXX","client\_id":XXX,"transaction\_id":XXX,"received\_ts":"XXX","replied\_ts":"XXX","client\_ip":"XX","verb":"GET","path":"/backend","status\_code":200,"user\_agent":"XXX","request\_bytes":0,"response\_bytes":150,"request\_disposition":"XXX","policy\_violation":null,"event\_id":"XXX","deployment\_type":null} ## Manage Logs and Troubleshoot If an error occurs during the metrics collection process, your Mule application’s ability to complete other tasks is not affected. Additionally, all entries related to the metrics collection is logged as `DEBUG` in the `com.mulesoft.mule.runtime.gw.metrics` package to avoid cluttering the log files. If you encounter issues with this feature: 1. Contact MuleSoft Support and supply them with the metrics logs listed in the previous section. 2. Disable the configuration until Support is able to resolve your issue. # Configure URI Template Regex You can specify a regular expression (regex) to include multiple paths when you apply a policy to a subset of resources exposed by an API. The **URI template regex** field in the policy enables you to specify this expression. When configuring **URI template regex**, you must consider the base path of the Mule runtime engine (Mule) application that implements (or proxies) the API. This is because Mule 4 resource-level policies depend on where an API is deployed. This diagram displays the list of methods used to specify the resource subset to apply to a policy: ![A list shows API endpoints and their corresponding GET and POST methods](/mulesoft/current/en-us/mule-gateway/_images/configure-regex-resources-list.png) Imagine that this API specification is implemented in the following Mule application: ```xml ``` In this example, `http:listener-config` defines both a `basePath` attribute and an additional path, v1, before the trailing **in the path `v1/`**. The concatenation of these two paths is referred to as the _base path_, which is `/api/v1`. To invoke the first resource of the API `resource-1`, you must use the base path in combination with the resource path `resource-1: [http://localhost:80/api/v1/resource-1](http://localhost:80/api/v1/resource-1)`. Subsequently, if you want to protect `resource-1` with a policy, you must use a resource-level policy. Therefore, the **URI template regex** that you specify when applying the policy must also include the base path in it: The diagram illustrates how to configure a **URI template regex**: ![A form that allows you to apply configurations to specific API methods and resources](/mulesoft/current/en-us/mule-gateway/_images/configure-uri-regex-example.png) If the API is of RAML or OAS type, the `Preview Resource Matching` option does not indicate that any resource is being matched, which differs from the actual runtime behavior. You can also use a regex to avoid having to explicitly specify the base path, for example, `.*/resource-1`. However, if you have resources with the same name at different levels of the API definition, the regex will match all of them, resulting in issues. This is because the regex will match with both `/api/v1/resource-1`, and `/api/v1/resources/resource-1`, which makes it an indecisive solution. ## [](#when-to-use-ignorebasepath)When to Use ignoreBasePath Including the base path in the full path of the resource when applying resource-level policies forces a coupling between the API in design time and the API in runtime. This is because you are required to know the base path where the API is going to reside when applying resource-level policies. To avoid this coupling issue, Mule 4.3.0 includes a new configuration that allows the Mule policy engine to ignore the base path of the API resource when matching the incoming HTTP request with the policy’s **URI template regex**. The configuration is exposed on the Mule application implementing the API: ```xml ``` When the `ignoreBasePath` attribute is set to `true`, the base path where the API is deployed is not considered anymore. ## [](#feature-prerequisites)Feature Prerequisites To implement this feature, ensure that your Mule application: - Is running in Mule 4.3.0 - Contains the Anypoint Connector for HTTP (HTTP Connector) 1.5.15 or later To achieve backward compatibility, this feature is disabled unless the attribute is explicitly set to `true`. If your Mule applications are running in Mule versions prior to 4.3.0 and have resource-level policies correctly configured, you do not need to make any changes to migrate to Mule 4.3.0 or later. The latest versions of API proxies available in API Manager are preconfigured to ignore the base path. To avoid breaking existing resource-level policies that are implemented using previous versions of API proxies, the following major versions of API proxies are released with this feature: - HTTP Proxy 2.0.0 - HTTP Proxy 3.0.0

Because resource-level policies work in compatibility mode in Mule versions 4.2.x and 4.1.x, deploying these proxy versions is not recommended. If you deploy these proxy versions, you will be required to update the URI Template configurations before migrating to Mule 4.3.x.

## [](#feature-limitations)Feature Limitations ### [](#base-path-requirements)Base Path Requirements The root path of an API must be well-defined to calculate the base path of the API. Make sure that the path attribute of the HTTP Listener in the Mule application ends with `*`. Otherwise, resource-level policy matching works as if `ignoreBasePath` is set to `false`. ### [](#query-parameter-exclusion)Query Parameter Exclusion The regex matches only against the URI path component of the request, and query parameters aren’t considered. For example, a regex pattern like `/api/products.*123` matches `/api/products/123` but won’t match `/api/products?id=123`. ## [](#see-also)See Also - [Policy Overview](https://docs.mulesoft.com/mule-gateway/policies-policy-overview) --- product: Mule Gateway --- # Configuring Mule Gateway API Autodiscovery in a Mule 4 Application > For the full documentation index, see: https://docs.mulesoft.com/llms.txt To configure API Autodiscovery in your Mule 4.x application, you must meet the following requirements: ## Making your API Available in API Manager The API to which you want to pair your Mule application must be available in API Manager. You can either: - Publish your API in Exchange and import it from there to API Manager. See [To Manage an API from Exchange](https://docs.mulesoft.com/api-manager/latest/create-instance-task-mule). - Import it directly from your machine. See [To Import an API Instance](https://docs.mulesoft.com/api-manager/latest/api-instance-landing-page) for more details. API Manager generates an "API ID" identifier for every imported API: ![An HTTP API instance with API Instance ID highlighted](/mulesoft/current/en-us/mule-gateway/_images/api-id.png) This API ID is required by the Autodiscovery element to identify the API to which you want to pair your application. ## Configuring API Manager This step is necessary to instruct API Manager to use your deployed Mule application as the API proxy itself. 1. For Managing type, select Basic Endpoint. 2. Add the Implementation URI that points to the deployed Mule application. 3. Select the checkmark `Check this box if you are managing this API in Mule 4 or above`. ## Configuring Anypoint Platform Organization Credentials in Mule Runtime To use Autodiscovery in a Mule application, Mule runtime engine must start with Anypoint Platform credentials already configured. Learn how to configure your organization credentials based on your deployment target in [Configuring Organization Credentials in Mule Runtime 4](https://docs.mulesoft.com/mule-gateway/mule-gateway-org-credentials-mule4). ## Configuring the Autodiscovery Element in Your Mule Application Within the code of your Mule application, you must configure the `api-gateway:Autodiscovery` element. The Autodiscovery element points to the specific API in API Manager to which you want to pair. > [!TIP] If you configured a proxy endpoint for your API, your autogenerated proxy will already be > correctly configured with the Autodiscovery element. XML element ```xml (2) ```
1Configure the apiId with the API ID that API Manager assigned to your API.
2Set the flowRef element to point to the flow that you want to pair to the API in API Manager. The referenced flow must use an HTTP Listener component. Other connectors that use HTTP as an underlying transport aren’t supported for policy enforcement.
You can either replace `${apiId}` with your specific value, or you can create a `config.properties` file where you define it in a key-value fashion: `apiId=[your-specific-value]` and reference it as `${apiId}` in this configuration. You can also configure this using Anypoint Studio’s UI: 1. In your existing flow, select the Global Elements tab in your Mule Configuration File editor. 2. Click the Create button, and look for the API Autodiscovery global element. ![A form for configuring global elements, with API Autodiscovery selected in a dropdown labeled Component configurations](/mulesoft/current/en-us/mule-gateway/_images/auto-discovery-studio-7.png) 3. Set the API ID and Flow Reference. ![A form displaying auto-discovery settings for an API](/mulesoft/current/en-us/mule-gateway/_images/auto-discovery-api-config.png) You can also choose to use the `${apiId}` value and reference it from a `config.properties` file. After the element is defined in the application, and the runtime is configured with your Anypoint Platform credentials, Mule Runtime will automatically track and keep up to date with the API configuration. defined in API Manager. ## Autodiscovery Configuration In Mule 4, the API is identified by the API Id and a reference to a Flow where the HTTP listener is defined using the `.` element. ## See Also - [Reviewing Mule Gateway API Autodiscovery concepts](https://docs.mulesoft.com/mule-gateway/mule-gateway-autodiscovery-overview) --- product: Mule Gateway --- # Configuring Organization Credentials in Mule Runtime 4 > For the full documentation index, see: https://docs.mulesoft.com/llms.txt Organization credentials provide a way to uniquely identify a specific environment, an organization, or a business group when linking Mule runtime engine (Mule) to an organization using Anypoint Platform. Credentials for environments, organizations, and business groups consist of two keys: the client ID and a client secret. Mule uses these credentials to connect to and access your organization. The recommended way to link Mule to Anypoint API Manager (API Manager), is by using the environment client ID and secret. You may also use the organization client ID and secret, or even business group credentials if you want to track APIs defined in business groups linked to Mule or belonging to a parent business group linked to Mule. When you use environment credentials, you can manage APIs that are specific to only that environment. If your APIs are in different environments of Anypoint Platform, you must specify instead the credentials of the organization that contains both environments. You can also use parent organization credentials to manage child organization APIs. For example, if ACME is the parent organization and Logistics is a business group (child organization) within ACME, your API Administrator can track APIs created in Logistics using the credentials of either Logistics or of ACME. You can identify client applications with client ID and secret. However, it is recommended that client application credentials not be used in place of organization credentials. Otherwise Mule is not linked correctly to the organization. You can only successfully pair Mule to your organization if Mule is started using Anypoint Platform credentials that are already configured. If you provision an adapter with organization credentials, you can manage APIs on only that specific adapter of your organization. ## Obtaining Credentials Because you are required to provide credentials from time to time when using API Manager, you might need to obtain these credentials for various client applications. You can obtain environment and organization credentials using the procedures explained in this section. ### Obtaining Environment Credentials (Recommended) To obtain environment credentials: 1. Log in to Anypoint Platform as an administrator, and click **Access Management**. 2. Click the **Environments** tab and click the name of your environment within your desired organization. ![The credentials for the environment in Mule 4](/mulesoft/current/en-us/mule-gateway/_images/environment-api-manager.png) Remember that environment credentials are only available in the post-crowd (November 2017) release version of the platform. ### Obtaining Organization Credentials To obtain organization credentials: 1. Log in to Anypoint Platform as an administrator, and click **Access Management**. 2. Click the **Organization** tab and click on the name of your organization or corresponding Business Group. ![A form displays organization information, including names, IDs, and a client secret in Mule 4](/mulesoft/current/en-us/mule-gateway/_images/orgid-api-manager.png) ## Configuring Credentials for Standalone Deployments ### Automatic Runtime Manager Agent Setup Mechanism If you are setting up a stand alone instance, and you would like to register the Runtime Manager agent: 1. Log in to Anypoint Platform as an administrator, and click **Runtime Manager**. 2. Click the **Servers** tab, then **Add Server**. 3. Run the command you are prompted to run. This command looks similar to this: ```text /bin/./amc_setup -H bb123456-789c-1234-9fd3-58f4b5e2d82e---123 server-name ``` Where `MULE_HOME` is a variable holding the root directory of the Mule installation. For example, `/opt/Mule/mule-enterprise-standalone/`. Executing this command configures your runtime agent, and the automatically adds the correct organization credentials to your Mule with the correct organization credentials and URLs, so your Mule is linked to a specific organization. After registering the agent, the wrapper.conf file is modified with the required data so configuration changes are made persistent. ### Manual Configuration If you are setting up an on premises instance to point to a specific organization, you need to add your credentials in the `wrapper.conf` file (persistent approach) or specifying the credentials data using the command line. #### Using the Wrapper.conf File The configuration file is placed in the `/conf` directory, where MULE\_HOME is a variable holding the root directory of the Mule installation. 1. Navigate to your $MULE\_HOME directory. 2. Open the file located in `/conf/wrapper.conf`. 3. Add your Anypoint Platform Organization credentials like shown below: ```text wrapper.java.additional.=-Danypoint.platform.client_id=XXXXXXXX wrapper.java.additional.=-Danypoint.platform.client_secret=XXXXXXXX ``` `` must be a unique number, not used by any other entry in that file. We recommend you to use the next incremental value over the previous entries in the list. If two or more lines use the same `` identifier, only the first value with that number is taken into account. If your organization is defined in the EU control plane, you need to define two additional keys: ```text wrapper.java.additional.=-Danypoint.platform.base_uri=https://eu1.anypoint.mulesoft.com wrapper.java.additional.=-Danypoint.platform.analytics_base_uri=https://analytics-ingest.eu1.anypoint.mulesoft.com ``` #### Using the Command Line You can pass your credentials at start up time by using the following arguments: Mac OS X / Linux ```console MULE_HOME/bin/mule \ -M-Danypoint.platform.client_id=XXXXXXXX \ -M-Danypoint.platform.client_secret=XXXXXXXX ``` Windows ```console MULE_HOME\bin\mule.bat -M-Danypoint.platform.client_id=XXXXXXXX -M-Danypoint.platform.client_secret=XXXXXXXX ``` If your organization is defined in the EU control plane, you should define the base URLS by adding two additional keys: Mac OS X / Linux ```console MULE_HOME/bin/mule \ -M-Danypoint.platform.client_id=XXXXXXXX \ -M-Danypoint.platform.client_secret=XXXXXXXX \ -M-Danypoint.platform.base_uri=https://eu1.anypoint.mulesoft.com \ -M-Danypoint.platform.analytics_base_uri=https://analytics-ingest.eu1.anypoint.mulesoft.com ``` Windows ```console MULE_HOME\bin\mule.bat -M-Danypoint.platform.client_id=XXXXXXXX -M-Danypoint.platform.client_secret=XXXXXXXX -M-Danypoint.platform.base_uri=https://eu1.anypoint.mulesoft.com -M-Danypoint.platform.analytics_base_uri=https://analytics-ingest.eu1.anypoint.mulesoft.com ``` The same applies if you are pointing at an organization defined in a Private Cloud Edition. You would need to provide the URLs for your Private Cloud Edition installation. ## Configuring Credentials for Anypoint Studio 7 You can configure Studio 7 to work with your Anypoint Platform organization for testing connectivity and governance applied to endpoints. 1. In Anypoint Studio, click **Anypoint Studio** from the top menu bar, and **Preferences**. 2. Under Anypoint Studio, click **API Manager** 3. Type in the client ID and secret under **Environment Credentials**: ![A form that enables the input of API platform and analytics URIs](/mulesoft/current/en-us/mule-gateway/_images/configure-autodiscovert-4-studio.png) If your organization is defined in the EU control plane, then you must also specify the base URL for that plane: ![A form for entering Anypoint Platform API pairing properties with fields for API platform, analytics URIs, and client credentials](/mulesoft/current/en-us/mule-gateway/_images/api-gateway-enabling-0cbca.png) The same applies if you are pointing at an organization defined in a Private Cloud Edition. You would need to provide the URLs for your Private Cloud Edition installation. ## Configuring Credentials in Runtime Manager for your Deployed Application ### Automatic Auto-generated Proxy Deploy Mechanism You can deploy an auto-generated proxy from your API directly to Cloudhub. 1. Log in to Anypoint Platform as an administrator, and click **API Manager**. 2. From the list of available APIs, click the API version of the API from which you want to auto-generate a proxy. 3. Click the **Settings** tab, and navigate to the **Deployment Configuration**. 4. Configure your runtime version and your proxy application name, and click **Deploy**. When you deploy a proxy using this mechanism, the system automatically configures the organization credentials (and URLs, if applicable) for you. You may take a look at them in Runtime Manager → → Settings → Properties. ### Manual Configuration 1. Navigate to **Runtime Manager** in Anypoint Platform. 2. Access the **Properties** section of the deployed application. If the application is being deployed for the first time, the Properties section will appear during the deployment configuration. 3. In the Properties section, add the following properties: ```text anypoint.platform.client_id=XXXXXXXX anypoint.platform.client_secret=XXXXXXXX ``` If your organization is defined in the EU control plane or using a Mule Private Cloud Edition, you should define the base URLS by adding two additional keys: ```text anypoint.platform.client_id=XXXXXXXX anypoint.platform.client_secret=XXXXXXXX anypoint.platform.base_uri=https://eu1.anypoint.mulesoft.com anypoint.platform.analytics_base_uri=https://analytics-ingest.eu1.anypoint.mulesoft.com ``` The same applies if you are pointing at an organization defined in a Private Cloud Edition. You would need to provide the URLs for your Private Cloud Edition installation. ## See Also - [Configuring Mule Gateway API Autodiscovery in a Mule 4 Application](https://docs.mulesoft.com/mule-gateway/mule-gateway-config-autodiscovery-mule4) --- product: Mule Gateway keywords: policy, endpoint --- # Configuring the Java Version of a Custom Policy > For the full documentation index, see: https://docs.mulesoft.com/llms.txt Mule Gateway custom policies can support different Java versions. To upgrade your custom policy to a newer version of Java, ensure that all policy dependencies support the new Java version and add the new Java version to your policy’s implementation metadata YAML file. After you upgrade the policy: 1. [Package the custom policy](https://docs.mulesoft.com/mule-gateway/policies-custom-package). 2. [Republish the custom policy to Exchange](https://docs.mulesoft.com/mule-gateway/policies-custom-upload-to-exchange). 3. [Upgrade your applied policies to the new policy version](https://docs.mulesoft.com/general/upgrade-policies-proxies). ## Before You Begin Before upgrading the Java version of your policy, ensure all dependencies are compatible with that Java version: - If your policy is using custom connectors, see [Custom Connectors Java Support](https://docs.mulesoft.com/general/java-support#custom-connectors) to upgrade them. - If your policy uses extensions provided by Mule API Gateway, update the version of the dependency in your `pom.xml` file to a version that supports your new Java version. For an example of how to use extensions in your custom policy, see [HTTP Policy Transform Extension](https://docs.mulesoft.com/mule-gateway/policies-custom-http-transform). To find the first Java 17-compatible version of the extension, see the following table. All versions support Java 8:

Extension artifact ID

First Java 17-compatible version

mule-client-id-enforcement-extension

1.2.0

mule-cors-extension

1.3.0

mule-event-authentication-extension

1.1.0

mule-federation-extension

1.4.0

mule-http-policy-transform-extension

3.2.0

mule-http-proxy-extension

1.2.0

mule-ip-filter-extension

2.1.0

mule-json-threat-protection-extension

1.2.0

mule-jwt-extension

1.3.0

mule-rest-validator-extension

2.3.0

mule-soap-fault

2.1.0

mule-throttling-extension

3.1.0

mule-tokenization-extension

1.2.0

mule-wsdl-functions-extension

1.2.0

mule-xml-threat-protection-extension

1.2.0

## Configure the Java Version of Your Policy For your policy to support different Java versions, you must modify the implementation metadata file to include the `supportedJavaVersions` field. The `supportedJavaVersions` supports the Java versions `8`, `11`, and `17`. If you do not include the `supportedJavaVersions` field, your policy supports only Java 8. As specified in [Before You Begin](#before-you-begin), all policy dependencies must also support the listed Java versions. For newer custom policies, your implementation metadata file and definition metadata file are split into two separate `YAML` files. However, for older policies, your implementation metadata file and definition metadata file might be included in the same `YAML` file. See the following sections the add the `supportedJavaVersions` to your relevant file structure: - [Split Model Policies](#split-model-policies) - [Non-Split Model Policies](#non-split-model-policies) ### Split Model Policies For split model policies, add the `supportedJavaVersions` field to the implementation metadata `YAML`, for example: ```yaml #%Policy Implementation 1.0 name: Basic Authentication - Simple - Mule4 technology: mule4 supportedJavaVersions: ["8", "11", "17"] minRuntimeVersion: 4.1.0 releaseNotes: | * Java 17 compatibility. ``` ### Non-Split Model Policies For older policies where implementation and definition metadata are found in the same `YAML` file, add the `supportedJavaVersions` field as follows: ```yaml id: basic-authentication-simple name: Basic authentication - Simple supportedPoliciesVersions: ">=v1" description: Enforces HTTP Basic authentication according to the details configured in the policy. category: Security violationCategory: authentication type: system resourceLevelSupported: true encryptionSupported: true standalone: true supportedJavaVersions: ["8", "11", "17"] requiredCharacteristics: [] providedCharacteristics: - Requires authentication configuration: - propertyName: username name: User Name type: string optional: false sensitive: false allowMultiple: false - propertyName: password name: User Password type: string optional: false sensitive: true allowMultiple: false ``` ## See Also - [Java Support](https://docs.mulesoft.com/general/java-support) - [Upgrading Java for Policies and API Proxies](https://docs.mulesoft.com/general/upgrade-policies-proxies) --- product: Mule Gateway keywords: cross origin resource sharing, cors, api gateway, mule gateway, gateway, policy --- # Cross-Origin Resource Sharing (CORS) Policy > For the full documentation index, see: https://docs.mulesoft.com/llms.txt

Policy name

Cross-Origin Resource Sharing (CORS)

Summary

Enables access to resources residing in external domains

Category

Compliance

First Mule version available

v4.1.1

Returned Status Codes

No return codes exist for this policy

## Summary CORS is a mechanism by which a web application can access resources that are defined in another domain. Browsers implement this standard by default. The CORS policy complies with the [CORS W3C recommendation](https://fetch.spec.whatwg.org/) standards. ## Configuring Policy Parameters ### Mule Gateway When you apply the policy to your API from the UI, the following parameters are displayed:
ElementDescriptionRequired?

Public resource

Whether the CORS configuration is to be applied as a public resource (default)

Yes

Default group

Whether the CORS configuration is to be applied only to specific resources (requires unselecting Public resource)

No

Support credentials

Whether the policy supports credentials, such as cookies, authorization headers, and TLS client certificates

No

## Configuration of CORS for non-API Gateway Mule Environments If your Mule runtime engine (Mule) is not enabled with API gateway capabilities and you need to implement the CORS functionality, you can use the CORS Interceptor. The CORS Interceptor is an element in the HTTP Listener configuration made available in Mule 4.0. The CORS configuration differs based on whether you leverage the CORS policy capabilities as a public resource or as a selected group of origins. For the Selected Group of Origins structure, the following example shows the elements that might be configured: ```XML (collection of origins) ... ... ... ``` For the Public Resource structure, the following example shows the elements that might be configured: ```XML ``` ## Why CORS CORS enables you to achieve web page security and web integrity in your environment. To know why you might need to apply the CORS policy to your backend, you must first understand _origins_, _cookies_, and how they can be manipulated to violate web page integrity. ### Introduction to the Web Origin Concept Origin is a header that specifies the request that initiated the fetch. The origin header includes only the server name (no path information). At a very basic level, an origin consists of: - URI scheme: `http://` - Host name: `www.example.com` - Port number: `8080` For requests between any two [origin](#origins) to be approved, the origins must be equal. Origins are considered equal only if all these three parameters match. For more information, see [RFC 6454 - The Web Origin Concept](https://datatracker.ietf.org/doc/html/rfc6454). ### HTTP Cookies Websites use HTTP cookies to retain stateful information. Most commonly, web servers use authentication cookies to know whether a user is logged in, and to know which account users are logged in to. For more information, see [RFC 6265](https://www.ietf.org/rfc/rfc6265.txt). SOP (same-origin policy) deters malicious attackers from exploiting cookies when one web page invokes another. For example, you might log in to your bank’s web page using a cookie that an attacker might be able to obtain and exploit to query the bank’s API on your behalf. With the SOP, scripts can access data from a target web page only if it has the same origin as the caller web page. For more information about origins, see [Wikipedia](https://en.wikipedia.org/wiki/Same-origin_policy). The following example illustrates the origin of the web page, `http://www.example.com:8080`: ![A table shows URL comparison results, including outcome and reason](/mulesoft/current/en-us/mule-gateway/_images/cors-policy-sop-example.png) Because the SOP is highly restrictive, access from one suborigin to another or to external hyperlinks do not work on web pages. For example, if an origin `www.testapply.com` has two suborigins, `www.eng.testapply.com` and `www.docs.testapply.com`, communication between the two suborigins is denied. Additionally, any hyperlinks to external websites from any of the suborigins is also denied. To circumvent this problem, web browsers implemented the CORS standard, which validates the web server and accepts the request if the validation is successful. For example, if your bank implements the CORS server-side protocol on its login server, you can query data only directly from the bank’s web page. Any attempt to query the login API from an external (non-bank) domain is denied. ## How CORS Works When your web pages request data, the browser detects whether the request is from within same origin and determines whether to apply the CORS algorithm. If you query data from a web page that is not in your origin, then the CORS policy is applied. The CORS algorithm works on the web server and on the client-side for the web page that requested the information. The client-side algorithm in the CORS policy is implemented by: - Determining whether the request is complex (and potentially dangerous) and sending a preliminary _preflight_ request to verify whether the server accepts the origin. - Executing the actual request and validating that the server responds correctly and accepts the origin. A _preflight_ is a preliminary request (using OPTIONS as the HTTP method) from the web browser to the backend server to test the identity (origin and a few other headers) of the web page that is trying to perform the request. If the backend does not accept the origin, the backend server responds to the request without a specific header (Access-Control-Allow-Origin). The client then understands that the page’s origin is not allowed in that server and does not execute the actual request. The following diagram shows the XMLHttpRequest (XHR) in a JavaScript flow for determining whether to execute the actual request: ![A flowchart illustrating the process of standard latency and added latency for Javascript cross-domain XHR calls](/mulesoft/current/en-us/mule-gateway/_images/cors-policy-xhr-diagram.png) As illustrated in the diagram, the request is validated based on the communication between the browser and the server: - If the request is considered to be complex (see the previous client-side diagram for XHR), then a preflight request is executed. If the server does not return the proper CORS response headers for the preflight, the client library (XHR in the previous example) is not allowed to perform the actual request. - If the preflight response is correct and complete, then the client library executes the actual request, which includes certain CORS headers. The client library then validates the CORS headers of the response. If some of the required headers are missing, then again the client library is obliged to block the response from reaching the client, which is usually a web page. ## CORS Components You can configure various components of the CORS policy, such as request headers, response headers, public resources and groups, ordering, and wildcards. ### CORS Request Headers - Origin: The origin making the cross origin request. - Access-Control-Request-Method: The method that is invoked in the actual request. This header is sent in the preflight request. - Access-Control-Request-Headers: Custom headers that are sent in the actual request. This header is sent in the preflight request. For the GET or HEAD methods, the standard defines a specific list of headers that are considered simple enough to not require a preflight. For custom headers, a preflight is executed for GET and HEAD requests (see the previous XHR example to validate the path in which the client does not have to perform a preflight). ### CORS Response Headers The headers included in a response depend on whether the request is a preflight or an actual request: - `Access-Control-Allow-Origin`: Obligatory in every response. If this header is not present in the response, the browser or client library blocks the response from reaching the web page. The wildcard “\*” can be used to represent any origin. - `Access-Control-Allow-Methods`: Allowed methods that can be executed. This header is returned in the OPTIONS request (preflight). The server might respond with a list of allowed methods, delegating the validation task to the client. - `Access-Control-Allow-Headers`: Allowed headers in the actual request. This header works in a manner similar to how Access-Control-Allow-Methods works . - `Access-Control-Allow-Credentials`: Notifies the client whether the actual request can be made with a cookie. The `Access-Control-Allow-Credentials` returns a Boolean value. - `Access-Control-Expose-Headers`: Provides the browser or client library with a list of headers that can be accessed by the web page that executed the request. The HTTP library performing the CORS request exposes only the headers to the web page, providing further privacy and security. - `Access-Control-Max-Age`: Specifies the duration (in seconds) in which the browser can avoid performing a second preflight on a request. ### Public Resources and Groups If you need to bypass the browser SOP, Mulesoft provides you an option to configure a public resource that enables the API gateway policy to mirror the preflight data in the response. This ensures that the actual request is correctly updated with all the CORS headers so that the browser accepts the response. If the public resource option is not secure enough for your environment, define multiple groups for the different origins that query your API. Each group applies to a list of origins and can specify different methods, headers, preflight caching time, and expose headers. ### Ordering The CORS policy is always applied first by the API gateway, before any other policies can be applied. If a protected request using OPTIONS is sent to an application that has the CORS policy applied, the request does not reach the protected resource. According to the [CORS specification](https://fetch.spec.whatwg.org/#resource-preflight-requests), all OPTIONS requests are considered preflight. ### Configuration Wildcards Wildcards (`*`) are accepted in the Origins and Headers sections of a group configuration. Use wildcards when you need a public resource, but must restrict the accepted HTTP methods. If you have configured multiple groups and one of the groups uses a wildcard origin, the non-wildcard settings override the wildcard configurations. ## FAQs **The CORS policy does not seem to be applied.** If you use tools such as curl or Postman to test the CORS policy for a complex request, the CORS request headers are not added and the preflight does not occur. If no CORS headers are sent or improper headers are used in the request, the API gateway CORS policy does not add any CORS response headers, giving the impression that the policy is not applied. Ensure that you use the libraries that implement the CORS protocol specific to your environment, or review the specification to ensure that you are configuring the correct headers. --- product: Mule Gateway --- # Custom Policies > For the full documentation index, see: https://docs.mulesoft.com/llms.txt Policies enforce regulations to help manage security, control traffic, and improve API adoption. For example, a policy can control authentication, access, and service level agreements (SLAs). You can create custom policies based on your specific business requirements and apply them to APIs to extend existing functionality or define new ones. The workflow to create custom policies for Mule 4 and earlier in Anypoint API Manager has not changed. Continue to use the process of developing the policy, packaging the custom policy, uploading it to Exchange, and applying the policy to an API through Anypoint API Manager as described in the Anypoint API Manager documentation. For more information, refer to the following: - [Publish a Mule 4 Custom Policy](https://docs.mulesoft.com/mule-gateway/policies-custom-mule-getting-started) - [Mule 4 Custom Policy Workflow](https://docs.mulesoft.com/mule-gateway/policies-custom-getting-started) - [Managing Offline Custom Policies](https://docs.mulesoft.com/mule-gateway/policies-custom-manage-offline) --- product: Mule Gateway --- # Custom Policy Development Reference > For the full documentation index, see: https://docs.mulesoft.com/llms.txt The Mule 4 engine provides powerful capabilities for building custom policies through its architecture and XML schema language. We use Maven to build and deploy Mule 4 policies. Policies consist of two files: 1. A deployable JAR file that contains the policy implementation. 2. A YAML Configuration File, where the policy parameters and metadata are defined. To package a policy in Maven, the development project must be composed of the following files - An XML template It contains the implementation of the policy using Mule’s XML schema language. - A YAML file It defines the configurable parameters of the policy. Anypoint API Manager uses this file to render the UI to display inputs for the policy. - The template’s `pom.xml` file It defines policy dependencies. The packaging type needs to be `mule-policy`. The `pom.xml` file may define any other Maven plugin that helps to manage the development lifecycle of the Maven project. - Resources Optional files that the policy depends on, such as certificates and configuration properties files. - The mule-artifact.json descriptor > [!NOTE] Policies cannot export resources nor packages such as Java classes. ## Basic XML structure Below is an example of the basic structure of a policy configuration: ```xml (1) (2) … (3) (4) … (5) ```
1The definition of a policy starts with the http-policy:proxy element with a name argument. The http-policy:proxy element must contain http-policy:source or a http-policy:operation element. In this example, http-policy:source is used.
2The http-policy:source block contains the actual instructions to execute, relative to the Mule flow the policy is configured to handle. The http-policy:source block can inject instructions before an HTTP Listener event fires at the start of a flow, and inject instructions after the flow completes.
3Any Mule Event operation that is defined before the execute-next element will be executed before the start of a flow with an HTTP Listener.
4The http-policy:execute-next element is required to continue the Mule Event processing. The http-policy:execute-next element can trigger other policies or the application flow. Any policy can stop the Mule Event processing chain by not executing http-policy:execute-next.
5Mule Event operations defined after the http-policy:execute-next element will be executed after the flow completes. These Mule Event processors will be able to process the Mule Event returned from the flow.
### Understanding execution order Consider the case where a Mule application contains two policies, A and B. Policy A has order 1 and Policy B has order 2. Policy A is defined by the following configuration: ```xml ``` And policy B config is: ```xml ``` A flow is defined as: ```xml ``` When an HTTP Request arrives at the Mule application’s endpoint, the execution order follows the diagram below: → → → → The policy with the lower order executes first. The flow will always execute in the middle of the policy operations. With this model, the Mule Event processing chain can be controlled with the presence or absence of the `http-policy:execute-next` element. For example, by placing the `http-policy:execute-next` element inside a `choice` element, the next Mule Event execution can continue or stop, depending on the choice condition. In the example below, the flow will only execute when the incoming request has a header named `myHeader` and its value is `someValue`. A message is logged if the incoming request does not satisfy the constraint. ```xml ``` ## Using extensions Policies, just like Mule applications, can make use of Mule extensions or plugins to extend the Mule Core capabilities. For example, a policy is required to add additional headers to the HTTP Response from a flow’s HTTP Listener. The first step is to add a Maven dependency that can modify an HTTP Request object. The `mule-http-policy-transform-extension` Mule plugin can modify HTTP Requests. ```xml com.mulesoft.anypoint mule-http-policy-transform-extension 1.0.0 mule-plugin ``` These examples are developed using Mule extension v1.0.0. Using a different version of the extension might cause the examples to not work as expected. To update your Mule extension version, see [HTTP Policy Transform Extension](https://docs.mulesoft.com/mule-gateway/policies-custom-http-transform). Next, the XML `http-transform` namespace must be added to expose the operations in the above dependency. ```xml #[{'policyHeader': 'policyHeaderValue'}] ``` If a policy needs to use custom code, the policy can either: 1. Import a custom Mule plugin programmed with the Java or XML SDK Extension 2. Use the `` element to add in custom scripts The recommended method is to use the SDK Extensions. > [!CAUTION] Custom policies can’t use connectors that export resources or packages such as Java > classes. For example, custom policies can’t use the Java or Spring connectors. ## Outbound policies Policies can be applied to outbound HTTP Requests within a flow as well. This capability enables policies to inject additional headers and other information into outbound HTTP traffic through an HTTP Requester defined in a flow. Below is an example of a policy that contains source and operation blocks: ```xml (1) … … (2) ```
1One http-policy:proxy element is used for both types of policy blocks. Both source and operation blocks may be present. When both blocks are present, each block can share variables to keep state throughout the policy execution.
2This policy block contains code to be executed after the flow’s HTTP Requester returns an HTTP response. If the flow does not contain an HTTP Requester element, then this block is never executed.
In general, the `http-policy:operation` block allows a policy to inject code before Mule execution reaches an HTTP Requester and after an HTTP Requester returns an HTTP response. The operation block can contain an `http-policy:execute-next` element to control operations before and after an HTTP Request in a flow. **Execution order example** There are two policies, A and B. Policy A has order 1 and Policy B has order 2. Policy A is defined by the following configuration: ```xml ``` And policy B config is: ```xml ``` A flow is defined as: ```xml ``` When Mule runtime receives an HTTP Request, the execution order is as shown in this diagram: → → → → → → → → → → Operation policies are only injected around the `http:request` operation. ## Error Handling Mule 4 policies can handle errors thrown by 1. The policy 2. A flow within the Mule application 3. Other policies Error handling can be accomplished using Mule 4’s `try` and `error-handler` elements. Once an error is caught by an `error-handler`, the error is either, propagated up the Mule Event processing chain, or handled, where normal Mule event process execution continues. For example, consider the following policy and flow: ```xml ``` ```xml ``` ### Scenario 1 Assume `` raises an error. The execution order follows the diagram below: → → → `` is not executed, and processing continues into the flow’s error-handler. Since the flow’s error-handler is configured not to propagate errors, `` will return to the policy and `` executes instead of the policy’s `error-handler`. ### Scenario 2 Assume `` raises an error. The execution order follows the diagram below: → From the example above, the flow never executes. ### Scenario 3 Assume now that the flow’s error handler propagates errors. ```xml ``` Assume `` raises an error. The execution order follows the diagram below: → → → The error gets propagated back to the policy, and the policy’s error handler continues handling the error. In summary, error handlers provide an alternative method to conditionally execute a flow within a policy. ## Classloading isolation ### Between policies Policies contain the same classloading isolation architecture seen in Mule 4 applications: any resource or library that a policy defines is not visible to other policies. ### Between a Policy and an Application Classloading between policies and Mule 4 applications is not completely isolated. This scenario is similar to classloading isolation between applications and domains: Any plugin, library, or resource visible to the application is also visible to any policy applied to that application. However, any plugin, library, or resource visible to a policy is **not** visible to the application applied. ### Dependency resolution If a policy and an application use different versions of the same dependency, the application’s dependency version will be used by the policy. You can read more on classloading isolation in the [Classloading Isolation](https://docs.mulesoft.com/mule-runtime/latest/about-classloading-isolation) topic. ## Variables and Event Scope A policy can define any number of variables. Variables within a policy scope can be shared between policy blocks. For example, a variable `maxCount` defined in a `http-policy:source` block is available in a subsequent `http-policy:operation` block. However, any variables defined in a policy are **not** available to other policies and to the application. Furthermore, variables defined by the application are not available to any policy. ## Mule message propagation in source policies Policies can make changes to the Mule message, but the changes may not get propagated, depending on where the Mule message changes are made relative to the `http-policy:execute-next` element. For source policies, any modification to a Mule Message made after the `http-policy:execute-next` element, will continue propagation throughout the rest of the Mule event processing chain. The below policy and flow illustrates this concept: ```xml ``` ```xml ``` The final response back to the client will be an HTTP Response that contains "Policy Message" as the body. However, modifications made before the `execute-next` element, are not propagated to the next policy or application by default. Consider the below policy and flow: ```xml ``` ```xml ``` The final response back to the client will be an HTTP Response that contains an empty body. Furthermore, the logger in the flow will log an empty payload. ### Propagating the Mule message Within the `http-policy:source` tag, set the attribute `propagateMessageTransformations` to `true` to enable propagation. ```xml ``` ```xml ``` The final response back to the client will be an HTTP Response that contains "Policy Message" as the body. The logger within the flow will log "Policy Message." This design prevents unintentional modifications that can affect the application. ## Mule message propagation in operation policies Mule message propagation is similar to source policies but in the opposite direction. In operation policies, modifications made before the `execute-next` element are always propagated. Modifications made after the `execute-next` element, are not propagated by default. Propagation can be enabled using the same attribute `propagateMessageTransformations` in the operation policy definition: ```xml … … ``` In summary, variables cannot be used to share information from a policy to other policies or Mule applications. However, Mule messages can be used to share information from a policy to other policies or Mule applications. Dependent on where the Mule message is set within a policy block, the attribute `propagateMessageTransformations` may need to be set to true to enable Mule message propagation. ## Authentication (Security Context) User authentication can be exposed through the Authentication object within the Security context object. If a policy sets the Authentication object, it will be available to other policies and to the application. The Authentication object can be accessed using DataWeave: #\[authentication.principal\] #\[authentication.password\] #\[authentication.properties.someProperty\] The only method to set the Authentication object is through a dependency using the SDK Mule extension. Refer to the [Authentication Handler](https://docs.mulesoft.com/mule-sdk/latest/authentication-handler) article to learn how to set the authentication object. Mule 4 Provided Policies use this exact method to propagate client information. ## YAML Configuration File Mule 4’s policies use YAML files to store metadata and user parameters. This flexible design allows a policy to work across multiple APIs that require different user parameters and configurations. For example, the Rate Limit Policy allows for different configurations based on user parameters: a user may want to allow up to 100 requests per minute on one API, and allow 5000 per minute on a different API. To allow user parameters, policy developers define user input in the YAML Configuration file. The file is then used by API Manager to render the UI for user input. **Example of a Client ID enforcement YAML file** ```yaml id: openam-access-token-enforcement (1) name: OpenAM access token enforcement (2) supportedPoliciesVersions: '>=v4' (3) supportedJavaVersions: ["8", "11", "17"] (4) description: Enforces access tokens by OpenAM. (5) category: Security (6) violationCategory: authentication (7) type: system (8) resourceLevelSupported: true (9) standalone: true (10) identityManagement: (11) type: OpenAM - OAuth 2.0 protected configuration: (12) - propertyName: scopes name: Scopes description: A space-separated list of supported scopes type: string optional: true sensitive: false allowMultiple: false - propertyName: exposeHeaders name: Expose Headers description: In a proxy scenario, defines if headers should be exposed in the request to the backend. The headers that may be sent are the user properties returned by the federation server when validating the access token with a 'X-AGW-' prefix. type: boolean optional: true defaultValue: true allowMultiple: false ```
1Unique ID within your organization of the policy. Required
2User friendly name that is used for displaying the policy name in API Manager’s UI. Required
3Deprecated property. Value should be set to ‘>=v1’ for now. Required
4Java versions supported by the policy. Required for Java 17 runtime support. Without this field, the policy won’t appear in API Manager for Java 17 runtimes. Optional
5Description of what the policy does. Also used in API Manager’s UI. Required
6Category to which the policy belongs. Used to group and filter policies in API Manager’s UI, any String value is valid. Required
7Value used by Edge to show metrics about different types of policy violations. Required
8Deprecated property. Value should be set to ‘system’. Required
9Whether resource level pointcuts should be enabled when applying the policy. Required
10Deprecated property. Value should be set to ‘true’. Required
11Whether policy requires information about an identity management that’s configured for the API’s Organization. Optional
12Where the policy parameters are defined. Every parameter listed here will be rendered as an expected user input in API Manager’s UI. It expects an array of values. Required
Below is the syntax for defining the above policy’s parameters: ```yaml propertyName: scopes (1) name: Scopes (2) description: A space-separated list of supported scopes (3) type: string (4) defaultValue: some String (5) optional: true (6) sensitive: false (7) allowMultiple: false (8) ```
1Internal name of the parameter. Must be unique within the policy.
2User friendly name of the parameter. Used for displaying in API Manager’s UI.
3Description of the parameter. Also, used for displaying in API Manager’s UI.
4Type of the parameter.
5Default value for the parameter.
6Whether is mandatory for the user to enter this value or not.
7Whether this property should be masked when entering in API Manager’s UI.
8Whether multiple values should be allowed for this parameter.
### Parameter types Depending of the type of the parameter, the UI will render a different type of input such as: - text boxes - radio buttons - checkboxes Some rendered elements require additional configurations. The list of elements that require additional configurations are: - **String**: Any string expected. - **Expression**: A DataWeave expression starting with #\[ and finished with \] is expected. - **Boolean**: true or false. - **Int**: A number is expected. This type requires additional properties: ```yaml minimumValue: -1 (1) maximumValue: 2147483647 (2) ```
1Minimum value allowed for the parameter.
2Maximum value allowed for the parameter.
- **Radio**: One value of a group of options. This type requires additional properties: ```yaml options: (1) - name: HTTP Basic Authentication Header value: httpBasicAuthenticationHeader - name: Custom Expression value: customExpression ```
1List of options for the user to choose. Each option has a name for displaying in the UI and an internal value used in the policy.
[...]
